1 #!/bin/sh -- # no runable script, just for vi
5 # we all like colorful messages
6 if expr match
"$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev
/null
&& \
7 expr match
"$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev
/null
; then
8 CERROR
="\e[1;31m" # red
9 CWARNING
="\e[1;33m" # yellow
10 CMSG
="\e[1;32m" # green
11 CINFO
="\e[1;96m" # light blue
12 CDEBUG
="\e[1;94m" # blue
13 CNORMAL
="\e[0;39m" # default system console color
14 CDONE
="\e[1;32m" # green
15 CPASS
="\e[1;32m" # green
16 CFAIL
="\e[1;31m" # red
17 CCMD
="\e[1;35m" # pink
20 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
21 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
23 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
26 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
27 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
28 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
29 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
32 echo -n "${CINFO}$1${CCMD} " >&2;
33 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
35 if [ -n "$1" ]; then shift; else break; fi
37 echo -n "…${CNORMAL} " >&2;
39 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
40 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
42 if [ $# -gt 0 ]; then echo "${CFAIL}FAIL: $*${CNORMAL}" >&2;
43 else echo "${CFAIL}FAIL${CNORMAL}" >&2; fi
44 EXIT_CODE
=$((EXIT_CODE+1));
47 # enable / disable Debugging
48 MSGLEVEL
=${MSGLEVEL:-3}
49 if [ $MSGLEVEL -le 0 ]; then
52 if [ $MSGLEVEL -le 1 ]; then
56 if [ $MSGLEVEL -le 2 ]; then
60 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
61 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
62 if [ -n "$CFAIL" ]; then
63 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
65 msgfail
() { echo -n " ###FAILED###" >&2; EXIT_CODE
=$((EXIT_CODE+1)); }
68 if [ $MSGLEVEL -le 3 ]; then
72 if [ $MSGLEVEL -le 4 ]; then
77 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
78 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
79 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
80 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
81 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
84 echo "${CDONE}DONE${CNORMAL}" >&2;
89 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
90 if [ -f .
/aptconfig.conf
]; then
91 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
92 elif [ -f ..
/aptconfig.conf
]; then
93 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
95 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
98 aptconfig
() { runapt apt
-config $
*; }
99 aptcache
() { runapt apt
-cache $
*; }
100 aptcdrom
() { runapt apt
-cdrom $
*; }
101 aptget
() { runapt apt
-get $
*; }
102 aptftparchive
() { runapt apt
-ftparchive $
*; }
103 aptkey
() { runapt apt
-key $
*; }
104 aptmark
() { runapt apt
-mark $
*; }
106 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
109 if [ -f .
/aptconfig.conf
]; then
110 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
111 elif [ -f ..
/aptconfig.conf
]; then
112 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
114 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
119 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
122 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/methods
/http
126 # error if we about to overflow, but ...
127 # "255 failures ought to be enough for everybody"
128 if [ $EXIT_CODE -gt 255 ]; then
129 msgdie
"Total failure count $EXIT_CODE too big"
131 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
134 shellsetedetector
() {
136 if [ "$exit_status" != '0' ]; then
137 echo >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}"
138 if [ "$EXIT_CODE" = '0' ]; then
139 EXIT_CODE
="$exit_status"
145 if [ "$1" = 'prefix' ]; then
146 CURRENTTRAP
="$2 $CURRENTTRAP"
148 CURRENTTRAP
="$CURRENTTRAP $1"
150 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
154 TMPWORKINGDIRECTORY
=$(mktemp -d)
155 TESTDIRECTORY
=$(readlink -f $(dirname $0))
156 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
157 BUILDDIRECTORY
="${TESTDIRECTORY}/../../build/bin"
158 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
159 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY;"
160 cd $TMPWORKINGDIRECTORY
161 mkdir rootdir aptarchive keys
163 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
164 mkdir -p var
/cache var
/lib var
/log
165 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
166 touch var
/lib
/dpkg
/available
168 ln -s ${BUILDDIRECTORY}/methods usr
/lib
/apt
/methods
170 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
171 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
172 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
174 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
175 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
176 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
178 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
179 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
180 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
181 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
182 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
183 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
184 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
185 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
186 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
187 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
188 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
189 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
190 if ! $(which dpkg) --assert-multi-arch >/dev
/null
2>&1; then
191 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
193 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
194 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
196 export PATH
="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
201 if [ "$1" = "native" -o -z "$1" ]; then
202 eval `aptconfig shell ARCH APT::Architecture`
203 if [ -n "$ARCH" ]; then
206 dpkg
--print-architecture
214 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
217 configarchitecture
() {
218 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
220 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
222 while [ -n "$1" ]; do
223 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
230 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
231 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
232 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
233 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
235 echo -n > rootdir/var/lib/dpkg/status
238 if $(which dpkg) --assert-multi-arch >/dev/null 2>&1; then
239 local ARCHS="$(getarchitectures)"
240 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
241 DPKGARCH="$(dpkg --print-architecture)"
242 for ARCH in ${ARCHS}; do
243 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
245 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
246 # dpkg doesn't really check the version as long as it is fully installed,
247 # but just to be sure we choose one above the required version
248 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
254 setupsimplenativepackage() {
258 local RELEASE="${4:-unstable}"
259 local DEPENDENCIES="$5"
260 local DESCRIPTION="$6"
261 local SECTION="${7:-others}"
263 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
266 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
268 local BUILDDIR=incoming/${NAME}-${VERSION}
269 mkdir -p ${BUILDDIR}/debian/source
271 echo "* most suckless software product ever
" > FEATURES
272 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
273 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
277 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
278 test -e debian/control || echo "Source
: $NAME
281 Maintainer
: Joe Sixpack
<joe@example.org
>
282 Build
-Depends: debhelper
(>= 7)
283 Standards
-Version: 3.9.1
285 Package
: $NAME" > debian/control
286 if [ "$ARCH" = 'all' ]; then
287 echo "Architecture
: all
" >> debian/control
289 echo "Architecture
: any
" >> debian/control
291 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
292 if [ -z "$DESCRIPTION" ]; then
293 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
294 If you
find such a package installed on your system
,
295 YOU did something horribly wrong
! They are autogenerated
296 und used only by testcases
for APT and surf no other propose…
" >> debian/control
298 echo "Description
: $DESCRIPTION" >> debian/control
300 test -e debian/compat || echo "7" > debian/compat
301 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
302 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
306 buildsimplenativepackage() {
310 local RELEASE="${4:-unstable}"
311 local DEPENDENCIES="$5"
312 local DESCRIPTION="$6"
313 local SECTION="${7:-others}"
314 local PRIORITY="${8:-optional}"
316 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
319 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
321 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
323 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
324 mkdir -p $BUILDDIR/debian/source
325 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
327 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
329 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
330 echo "$NAME ($VERSION) $RELEASE; urgency
=low
334 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
338 Maintainer
: Joe Sixpack
<joe@example.org
>
339 Standards
-Version: 3.9.3" > ${BUILDDIR}/debian/control
340 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
341 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
343 Package
: $NAME" >> ${BUILDDIR}/debian/control
345 if [ "$ARCH" = 'all' ]; then
346 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
348 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
350 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
351 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
352 if [ -z "$DESCRIPTION" ]; then
353 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
354 If you
find such a package installed on your system
,
355 YOU did something horribly wrong
! They are autogenerated
356 und used only by testcases
for APT and surf no other propose…
" >> ${BUILDDIR}/debian/control
358 echo "Description
: $DESCRIPTION" >> ${BUILDDIR}/debian/control
361 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
362 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
364 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
365 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
366 # gpg --yes --no-default-keyring --secret-keyring ./keys/joesixpack.sec \
367 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
368 # --clearsign -o "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
369 # mv "${BUILDDIR}/..
/${SRC}.sign
" "${BUILDDIR}/..
/$SRC"
373 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
374 rm -rf ${BUILDDIR}/debian
/tmp
375 mkdir -p ${BUILDDIR}/debian
/tmp
/DEBIAN
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
376 cp ${BUILDDIR}/debian
/copyright
${BUILDDIR}/debian
/changelog
${BUILDDIR}/FEATURES
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME}
377 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
/${NAME}-${arch}
378 (cd ${BUILDDIR}; dpkg
-gencontrol -DArchitecture=$arch)
379 (cd ${BUILDDIR}/debian
/tmp
; md5sum $(find usr/ -type f) > DEBIAN
/md5sums
)
381 dpkg
-deb --build ${BUILDDIR}/debian
/tmp
${BUILDDIR}/..
2> /dev
/null
> /dev
/null
382 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.pkglist
385 mkdir -p ${BUILDDIR}/..
/${NAME}_
${VERSION}
386 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}/
387 cp ${BUILDDIR}/debian
/changelog
${BUILDDIR}/..
/${NAME}_
${VERSION}.changelog
396 local ARCH
=$(getarchitecture $4)
397 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
399 if [ "$ARCH" = "all" ]; then
400 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
402 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
403 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
404 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
407 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
410 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
416 if [ -d incoming
]; then
417 buildaptarchivefromincoming $
*
419 buildaptarchivefromfiles $
*
423 createaptftparchiveconfig
() {
424 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
425 if [ -z "$ARCHS" ]; then
426 # the pool is empty, so we will operate on faked packages - let us use the configured archs
427 ARCHS
="$(getarchitectures)"
430 ArchiveDir "' >> ftparchive.conf
431 echo -n $(readlink -f .) >> ftparchive.conf
433 CacheDir "' >> ftparchive.conf
434 echo -n $(readlink -f ..) >> ftparchive.conf
436 FileListDir "' >> ftparchive.conf
437 echo -n $(readlink -f pool/) >> ftparchive.conf
441 Packages::Compress ". gzip bzip2 lzma xz";
442 Sources::Compress ". gzip bzip2 lzma xz";
443 Contents::Compress ". gzip bzip2 lzma xz";
444 Translation::Compress ". gzip bzip2 lzma xz";
445 LongDescription "false";
449 SrcDirectory "pool/";
455 Label "apttestcases";
457 Description "repository with dummy packages";
458 Architectures "' >> ftparchive.conf
459 echo -n "$ARCHS" >> ftparchive.conf
463 };' >> ftparchive.conf
464 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
465 echo -n 'tree "dists/' >> ftparchive.conf
466 echo -n "$DIST" >> ftparchive.conf
468 Architectures "' >> ftparchive.conf
469 echo -n "$ARCHS" >> ftparchive.conf
471 FileList "' >> ftparchive.conf
472 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
474 SourceFileList "' >> ftparchive.conf
475 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
477 Sections "' >> ftparchive.conf
478 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
480 };' >> ftparchive.conf
484 buildaptftparchivedirectorystructure
() {
485 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
486 for DIST
in $DISTS; do
487 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
488 for SECTION
in $SECTIONS; do
489 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
490 for ARCH
in $ARCHS; do
491 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
493 mkdir -p dists
/${DIST}/${SECTION}/source
494 mkdir -p dists
/${DIST}/${SECTION}/i18n
504 local DEPENDENCIES
="$5"
505 local PRIORITY
="${6:-optional}"
506 local DESCRIPTION
="${7}"
508 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
509 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
510 ARCHS
="$(getarchitectures)"
514 for BUILDARCH
in $ARCHS; do
515 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
516 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
517 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
518 local FILE
="${PPATH}/Packages"
523 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
524 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
525 echo "Version: $VERSION
526 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
527 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
528 echo -n 'Description: ' >> $FILE
529 if [ -z "$DESCRIPTION" ]; then
530 echo "an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
531 If you find such a package installed on your system,
532 YOU did something horribly wrong! They are autogenerated
533 und used only by testcases for APT and surf no other propose…" >> $FILE
535 echo "$DESCRIPTION" >> $FILE
547 local DEPENDENCIES
="$5"
549 local SPATH
="aptarchive/dists/${RELEASE}/main/source"
551 local FILE
="${SPATH}/Sources"
555 Maintainer: Joe Sixpack <joe@example.org>
556 Architecture: $ARCH" >> $FILE
557 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
559 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
560 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
564 insertinstalledpackage
() {
568 local DEPENDENCIES
="$4"
569 local PRIORITY
="${5:-optional}"
570 local STATUS
="${6:-install ok installed}"
571 local FILE
='rootdir/var/lib/dpkg/status'
572 local INFO
='rootdir/var/lib/dpkg/info'
573 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
579 Maintainer: Joe Sixpack <joe@example.org>
580 Version: $VERSION" >> $FILE
581 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
582 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
583 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
584 If you find such a package installed on your system,
585 YOU did something horribly wrong! They are autogenerated
586 und used only by testcases for APT and surf no other propose…
588 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
589 echo -n > ${INFO}/${NAME}:${arch}.list
591 echo -n > ${INFO}/${NAME}.list
597 buildaptarchivefromincoming
() {
598 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
600 [ -e pool
] || ln -s ..
/incoming pool
601 [ -e ftparchive.conf
] || createaptftparchiveconfig
602 [ -e dists
] || buildaptftparchivedirectorystructure
603 msgninfo
"\tGenerate Packages, Sources and Contents files… "
604 aptftparchive
-qq generate ftparchive.conf
610 buildaptarchivefromfiles
() {
611 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
612 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
613 msgninfo
"\t${line} file… "
614 cat ${line} | gzip > ${line}.gz
615 cat ${line} | bzip2 > ${line}.bz2
616 cat ${line} | xz
--format=lzma
> ${line}.lzma
617 cat ${line} | xz
> ${line}.xz
619 touch -d "$1" ${line}.gz
${line}.bz2
${line}.lzma
${line}.xz
623 generatereleasefiles
"$@"
626 # can be overridden by testcases for their pleasure
627 getcodenamefromsuite
() { echo -n "$1"; }
628 getreleaseversionfromsuite
() { true
; }
629 getlabelfromsuite
() { true
; }
631 generatereleasefiles
() {
632 # $1 is the Date header and $2 is the ValidUntil header to be set
633 # both should be given in notation date/touch can understand
634 msgninfo
"\tGenerate Release files… "
635 if [ -e aptarchive
/dists
]; then
636 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
637 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
638 local CODENAME
="$(getcodenamefromsuite $SUITE)"
639 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
640 local LABEL
="$(getlabelfromsuite $SUITE)"
641 if [ -n "$VERSION" ]; then
642 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
644 if [ -n "$LABEL" ]; then
645 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
647 aptftparchive
-qq release
$dir \
648 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
649 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
652 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
653 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
655 NotAutomatic: yes' $dir/Release
657 if [ -n "$1" -a "$1" != "now" ]; then
658 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
662 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
666 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
668 if [ -n "$1" -a "$1" != "now" ]; then
669 for release
in $(find ./aptarchive -name 'Release'); do
670 touch -d "$1" $release
676 setupdistsaptarchive
() {
677 local APTARCHIVE
=$(readlink -f ./aptarchive)
678 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
679 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
680 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
681 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
682 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
683 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
684 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
689 setupflataptarchive
() {
690 local APTARCHIVE
=$(readlink -f ./aptarchive)
691 if [ -f ${APTARCHIVE}/Packages
]; then
692 msgninfo
"\tadd deb sources.list line… "
693 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
696 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
698 if [ -f ${APTARCHIVE}/Sources
]; then
699 msgninfo
"\tadd deb-src sources.list line… "
700 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
703 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
709 if [ -e aptarchive
/dists
]; then
715 if [ "$1" != '--no-update' ]; then
716 msgninfo
"\tSync APT's cache with the archive… "
723 local SIGNER
="${1:-Joe Sixpack}"
724 local GPG
="gpg --batch --yes --no-default-keyring --trustdb-name rootdir/etc/apt/trustdb.gpg"
725 msgninfo
"\tSign archive with $SIGNER key… "
726 local REXKEY
='keys/rexexpired'
727 local SECEXPIREBAK
="${REXKEY}.sec.bak"
728 local PUBEXPIREBAK
="${REXKEY}.pub.bak"
729 if [ "${SIGNER}" = 'Rex Expired' ]; then
730 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
731 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
732 # therefore we 'temporary' make the key not expired and restore a backup after signing
733 cp ${REXKEY}.sec
$SECEXPIREBAK
734 cp ${REXKEY}.pub
$PUBEXPIREBAK
735 local SECUNEXPIRED
="${REXKEY}.sec.unexpired"
736 local PUBUNEXPIRED
="${REXKEY}.pub.unexpired"
737 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
738 cp $SECUNEXPIRED ${REXKEY}.sec
739 cp $PUBUNEXPIRED ${REXKEY}.pub
741 printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub
--secret-keyring ${REXKEY}.sec
--command-fd 0 --edit-key "${SIGNER}" >/dev
/null
2>&1 || true
742 cp ${REXKEY}.sec
$SECUNEXPIRED
743 cp ${REXKEY}.pub
$PUBUNEXPIRED
746 for KEY
in $(find keys/ -name '*.sec'); do
747 GPG
="$GPG --secret-keyring $KEY"
749 for KEY
in $(find keys/ -name '*.pub'); do
750 GPG
="$GPG --keyring $KEY"
752 for RELEASE
in $(find aptarchive/ -name Release); do
753 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg
${RELEASE}
754 local INRELEASE
="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
755 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
756 # we might have set a specific date for the Release file, so copy it
757 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg
${INRELEASE}
759 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
760 mv -f $SECEXPIREBAK ${REXKEY}.sec
761 mv -f $PUBEXPIREBAK ${REXKEY}.pub
766 changetowebserver
() {
767 local LOG
='/dev/null'
768 if test -x ${BUILDDIRECTORY}/aptwebserver
; then
770 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/aptwebserver
-o aptwebserver
::fork
=1 "$@" >$LOG 2>&1
771 local PID
="$(cat aptwebserver.pid)"
772 if [ -z "$PID" ]; then
773 msgdie
'Could not fork aptwebserver successfully'
777 elif [ $# -gt 0 ]; then
778 msgdie
'Need the aptwebserver when passing arguments for the webserver'
779 elif which weborf
> /dev
/null
; then
780 weborf
-xb aptarchive
/ >$LOG 2>&1 &
782 elif which gatling
> /dev
/null
; then
784 gatling
-p 8080 -F -S >$LOG 2>&1 &
787 elif which lighttpd
> /dev
/null
; then
788 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
790 server.stat-cache-engine = \"disable\"" > lighttpd.conf
791 lighttpd
-t -f lighttpd.conf
>/dev
/null
|| msgdie
'Can not change to webserver: our lighttpd config is invalid'
792 lighttpd
-D -f lighttpd.conf
>$LOG 2>&1 &
795 msgdie
'You have to build aptwerbserver or install a webserver'
797 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
798 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
799 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
805 mkdir -p rootdir
/media
/cdrom
/.disk
806 local CD
="$(readlink -f rootdir/media/cdrom)"
807 echo "acquire::cdrom::mount \"${CD}\";" > rootdir
/etc
/apt
/apt.conf.d
/00cdrom
808 echo 'acquire::cdrom::autodetect 0;' >> rootdir
/etc
/apt
/apt.conf.d
/00cdrom
809 echo -n "$1" > ${CD}/.disk
/info
810 if [ ! -d aptarchive
/dists
]; then
811 msgdie
'Flat file archive cdroms can not be created currently'
814 mv aptarchive
/dists
$CD
815 ln -s "$(readlink -f ./incoming)" $CD/pool
816 find rootdir
/etc
/apt
/sources.list.d
/ -name 'apt-test-*.list' -delete
820 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
821 if [ -n "$DIFFTEXT" ]; then
833 msgtest
"Test for correctness of file" "$FILE"
835 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
837 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
842 msgtest
"Test for no output of" "$*"
843 test -z "$($* 2>&1)" && msgpass
|| msgfail
847 local COMPAREFILE
=$(mktemp)
848 addtrap
"rm $COMPAREFILE;"
849 echo "$1" > $COMPAREFILE
851 msgtest
"Test for equality of" "$*"
852 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
856 local COMPAREFILE1
=$(mktemp)
857 local COMPAREFILE2
=$(mktemp)
858 local COMPAREAGAINST
=$(mktemp)
859 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
860 echo "$1" > $COMPAREFILE1
861 echo "$2" > $COMPAREFILE2
863 msgtest
"Test for equality OR of" "$*"
864 $
* >$COMPAREAGAINST 2>&1
865 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
866 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
867 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
868 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
873 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
876 while [ -n "$1" ]; do
878 N: Can't select versions from package '$1' as it is purely virtual"
879 PACKAGE
="${PACKAGE} $1"
882 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
884 N: No packages found"
885 local COMPAREFILE
=$(mktemp)
886 addtrap
"rm $COMPAREFILE;"
887 local ARCH
="$(getarchitecture 'native')"
888 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
889 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
893 msgtest
"Test for non-existent packages" "apt-cache show $*"
894 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
895 if [ -n "$SHOWPKG" ]; then
904 testdpkginstalled
() {
905 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
906 local PKGS
="$(dpkg -l $* 2>/dev/null | grep '^i' | wc -l)"
907 if [ "$PKGS" != $# ]; then
909 dpkg
-l $
* | grep '^[a-z]'
916 testdpkgnotinstalled
() {
917 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
918 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
919 if [ "$PKGS" != 0 ]; then
921 dpkg
-l $
* | grep '^[a-z]'
929 local COMPAREFILE
=$(mktemp)
930 addtrap
"rm $COMPAREFILE;"
932 msgtest
'Test for correctly marked as auto-installed' "$*"
933 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
935 msgtest
'Test for correctly marked as auto-installed' 'no package'
936 echo -n > $COMPAREFILE
938 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
942 if [ "$1" = '--nomsg' ]; then
945 msgtest
'Test for successful execution of' "$*"
947 local OUTPUT
=$(mktemp)
948 addtrap
"rm $OUTPUT;"
949 if $@
>${OUTPUT} 2>&1; then
959 if [ "$1" = '--nomsg' ]; then
962 msgtest
'Test for failure in execution of' "$*"
964 local OUTPUT
=$(mktemp)
965 addtrap
"rm $OUTPUT;"
966 if $@
>${OUTPUT} 2>&1; then
976 echo "STOPPED execution. Press enter to continue"